#######################################################################
### MP Fénelon Sainte-Marie --- algorithme knn
#######################################################################

import numpy.random as rd
import numpy as np
import time
#import matplotlib.pyplot as plt
#plt.clf()

# Chque donnée est de type [x(0), ..., x(d-1), classe]
# Chacune de ces données est donc de taille d+1.

N = 1000
NbDeClasses = 10
print('Nombre      de      classes      :',NbDeClasses)
Donnees = []
NbDeDonnees = N * NbDeClasses
d = 10 # la dimension des vecteurs à classer
print('Dimension    des    données      :',d)

#######################################################################

# Construction de N données aléatoires pour chacune des classes

# Pour éloigner les classes de données les unes des autres
# on décale les vecteurs de c * delta
delta = 0.3
print('espacement        delta          :',delta)

for c in range(NbDeClasses):                               # pour chacune des c classes...
    for i in range(N):                                     # ... on construit N données
        Donnees.append( [rd.random() + c * delta for j in range(d)] + [c]) # ... de taille d+1

# Mélange des données

rd.shuffle(Donnees)

# 75% des données pour l'apprentissage et 25% pour le test

DonneesEntrainement = Donnees[0:int(NbDeDonnees*0.75)]
DonneesTest = Donnees[int(NbDeDonnees*0.75):]

# Distance euclidienne entre deux données

def distance(d1,d2):
    # Chacune étant de type [x(0), ..., x(d-1), classe]
    resu = 0
    for i in range(len(d1)-1):
        resu = resu + (d1[i]-d2[i])**2
    return np.sqrt(resu)

#######################################################################
# Prédiction de la classe d'une donnée à l'aide du jeu de données 'Entrainement'

def knnPrediction(Entrainement,donnee,k):
    global T1, T2, T3
    # Prédiction de la classe de l'élément 'donnee'
    # à l'aide des données d'entraînement, pour la méthode knn avec k voisins
    
    # Construction de la liste des couples [classe de d_i, distance de d_i à donnee]
    L = [] # La liste en question
    t1 = time.time()
    for data in Entrainement:
        dist = distance(data,donnee)
        L.append([data[-1],dist])
    T1 = T1 + time.time()-t1
    
    # Tri de Distances selon la première coordonnée décroissante
    t2 = time.time()
    L.sort(key = lambda elem: elem[1])
    T2 = T2 + time.time()-t2

    # Récupération des k plus proches voisins de donnee
    t3 = time.time()
    kPlusProches = L[:k]
    
    # Comptage des occurrences des classes des k plus proches voisins
    compteur = [0 for i in range(NbDeClasses)]
    
    for voisin in kPlusProches:
        compteur[voisin[0]] = compteur[voisin[0]] + 1
    
    # Parmi les k plus proches voisins, recherche de la classe de compteur le plus élevé
    maximum = 0
    for i in range(NbDeClasses):
        if compteur[i] > maximum:
            classe = i
            maximum = compteur[i]
    T3 = T3 + time.time()-t3

    return classe

"""
DonneeTest = [1.1,0.9,1.,2]
print('Donnée test :',DonneeTest)
ClasseTest = knnPrediction(DonneesEntrainement,DonneeTest,5)
#print('L\'échantillon',DonneeTest,' est de type',Couleurs[ClasseTest])
"""

#######################################################################
# Prédiction de la classe des éléments de la liste 'Test' grâce à la liste 'Entrainement'

def knnTest(Entrainement,Test,k):
    # Prédiction de la classe de tous les éléments de la liste Test,
    # à l'aide des données de la liste Entraînement, pour la méthode knn avec k voisins.
    # La liste à tester n'est pas modifiée !
    
    # Copie de la liste à tester
    TestBis = np.copy(Test)
    
    for test in TestBis:
        prediction = knnPrediction(Entrainement,test,k)
        test[-1] = prediction
    
    # Renvoi de la liste testée
    return TestBis

#######################################################################
# Comptage du nombre de données correctement catégorisées

def Comptage(Entrainement,Test,k):
    # Décompte des éléments bien catégorisés
    
    # On commence par catégoriser tous les éléments de la liste Test
    TestBis = knnTest(Entrainement,Test,k)
    
    compteur = 0
    for i in range(len(Test)):
        if Test[i][-1]==TestBis[i][-1]:
            compteur = compteur + 1
    
    return compteur

#k = int(np.sqrt(NbDeDonnees))
k = 5
print('Nombre   total   de   données    :',len(Donnees))
print('Nombre de données d\'entraînement :',len(DonneesEntrainement))
print('Nombre  de  données  à  tester   :',len(DonneesTest))
print('k =',k)
T1, T2, T3 = 0, 0, 0
TauxReussite = Comptage(DonneesEntrainement,DonneesTest,k) * 100 / len(DonneesTest)
print('Taux de réussite :',TauxReussite)

print('Calcul des distances en ',T1,'secondes')
print('Tri des distances en ',T2,'secondes')
print('fin de l algorithme en ',T3,'secondes')
